-- PBS.lua v2.0 -- by Safa
--
-- Do various modding tasks using Automato PBS UI or Keyboard Shortcuts. Get notified when new posts are present.

dofile("common.inc");
--dofile("pbs_logger.inc");
--Uses pbslog.txt to save modding history.

askText = singleLine([[
  EPBS v2.0 - 29/10 (by Safa) ATITD Clock must be visible. Hit SHIFT to begin.
]]);

--Done Modding
is_done = false;
--Amount of time to pause after clicking the plane woods button (ms)
pause_time = 1000; 
--Automato Window Size
automato = lsGetWindowSize();
--Used by Timer to determine a second is passed.
frame = 0;
notifyOnce = 0;
animation_beep = 3000;
animation_readScreen = 0;
animation_postSent = 0;
	--Timer
	h=0;
	m=0;
	s=0;
--Number of posts approved/posted.
p_yes=0;
p_saved =0;
--Settings
ui_size = "Default";
sounds = "Loop";
logsession = "On";
--Sound Files
s_newpost = "beepping.wav";
s_start = "start.wav";
s_posted = "scribble.wav";
s_saved = "saved.wav";
s_success = "successful.wav";
--State.  0:Waiting for Posts  1: Post Pending  2: Settings 3: Post Sent
State=0;

function doit()
  askForWindow(askText);
  findClockInfo();
  askForFocus();
  lsPlaySound("start.wav");
  startModding();
end

function exitButton()
--Return to Automato Scripts List if "End Script" is pressed.
  if lsButtonText(0 - 20, lsScreenY - 30, z, 200, 0x000000FF, "Log & Exit") then
    if logsession == "On" then
    LogSession();
	end
	is_done = 1;
  end
end

function exitButtonSmall()
--Return to Automato Scripts List if "End Script" is pressed.
  if lsButtonText(0, 60, z, lsScreenX, 0x000000FF, "Log & Exit") then
	if logsession == "On" then
    LogSession();
	end
	is_done = 1;
  end
end

function PBSLog(Text)
	FileFish = io.open("pbslog.txt","a+");
	FileFish:write(Text);
	FileFish:close();
end

function LogSession()
--Time Macro Stopped. (for pbslog.txt)
findClockInfo();
timeStopped = "[" .. Date .. ", " .. Time .. "] ";
--Log information about this modding session.
  if p_yes < 10 then
    PBSLog("  " .. timeStarted .. "   " .. timeStopped .. "            -00" .. p_yes .. "-                 (" .. h .. "h" ..  m .. "m".. s .. "s) \n");
  elseif p_yes < 100 then
	PBSLog("  " .. timeStarted .. "   " .. timeStopped .. "            -0" .. p_yes .. "-                 (" .. h .. "h" ..  m .. "m".. s .. "s) \n");
  else
	PBSLog("  " .. timeStarted .. "   " .. timeStopped .. "            -" .. p_yes .. "-                 (" .. h .. "h" ..  m .. "m".. s .. "s) \n");
  end
end

function findClockInfo()
	srReadScreen();
  anchor = findText("Year");
  if(not anchor) then
    anchor = findText("ar 1");
  end
  if(not anchor) then

    anchor = findText("ar 2");
  end
  if(not anchor) then
    anchor = findText("ar 3");
  end
  if(not anchor) then
    anchor = findText("ar 4");
  end
  if(not anchor) then
    anchor = findText("ar 5");
  end
  if(not anchor) then
    anchor = findText("ar 6");
  end
  if(not anchor) then
    anchor = findText("ar 7");
  end
  if(not anchor) then
    anchor = findText("ar 8");
  end
  if(not anchor) then
    anchor = findText("ar 9");
  end


  if anchor then
    lsPrintln("Found Clock");
    window = getWindowBorders(anchor[0], anchor[1]);
    lines = findAllText(nil, window, NOPIN);
    for i=1,#lines do
      --lsPrintln("LINE " .. i .. " : " .. table.concat(lines[i], ","));

	theDateTime = table.concat(lines[1], ",") -- Line 1 on the clock
	theDateTime = string.sub(theDateTime,string.find(theDateTime,",") + 1);
	regionCoords = table.concat(lines[2], ",") -- Line 2 on the clock
	regionCoords = string.sub(regionCoords,string.find(regionCoords,",") + 1);
	Coordinates = string.sub(regionCoords,string.find(regionCoords,":") + 2);
	stripYear = string.sub(theDateTime,string.find(theDateTime,",") + 2);
	Time = string.sub(stripYear,string.find(stripYear,",") + 2);
	stripYear = "," .. stripYear
	Date = string.sub(stripYear,string.find(stripYear,",") + 1, string.len(stripYear) - string.len(Time) - 2);
      --lsPrintln(theDateTime .. "\nCoords: " .. Coordinates .. " (" .. string.len(Coordinates) .. ")\nTime: " .. Time .. " (" .. string.len(Time) .. ")\nDate: " .. Date .. " (" .. string.len(Date) .. ")");

    end
  end
end

function updateTimer()
  if frame > 1000 then
	frame = 0;
	s = s + 1;
	 if s == 60 then
	   s = 0;
	   m = m + 1;
	 end
	 if m == 60 then
	  m = 0;
	  s = 0;
	  h = h + 1;
	 end
  end
end

function waitForPosts()
  if ui_size == "Default" then -- UI Size Default
--Show time passed below microphone.
	updateTimer();
	if lsButtonImg(200, 50, 8, 0.10, 0xFFFFFFff, "pbs/settings.png") then
	  State = 2;
    end
	if p_saved == 1 then
	  lsPrint(85, 10, 2, 0.6, 0.6, 0x55AAAAFF, "Holding saved post(s).");
	end
	lsPrint(90, 25, 2, 0.7, 0.7, 0xFFFFFFFF, "Waiting for posts");
	if p_yes < 10 then
    lsPrint(55, 130, 2, 2.0, 2.0, 0xFFFFFFff, "00" .. p_yes);
    elseif p_yes < 100 then
	lsPrint(55, 130, 2, 2.0, 2.0, 0xFFFFFFFF, "0" .. p_yes);
    else
	lsPrint(55, 130, 2, 2.0, 2.0, 0xFFFFFFFF, p_yes);
    end
	lsPrint(120, 220, 2, 0.7, 0.7, 0xFFFFFFFF, "(" .. h .. "h" ..  m .. "m".. s .. "s)");
	lsButtonImg(50, 50, 1, 0.40, 0xFFFFFFff, "pbs/microphone.png");
	exitButton();
  else -- UI Size Toolbar
    updateTimer();
	if lsButtonImg(240, 5, 5, 0.10, 0xFFFFFFff, "pbs/settings.png") then
	  State = 2;
    end
	if p_saved == 1 then
	  lsPrint(85, 10, 2, 0.6, 0.6, 0x55AAAAFF, "Holding saved post(s).");
	end
	lsPrint(140, 15, 2, 0.5, 0.5, 0xFFFFFFFF, "Waiting for posts");
	lsPrint(65, 7, 2, 2.0, 2.0, 0xFFFFFFFF, p_yes);
	lsPrint(150, 30, 2, 0.7, 0.7, 0xFFFFFFFF, "(" .. h .. "h" ..  m .. "m".. s .. "s)");
	lsButtonImg(5, 5, 1, 0.10, 0xFFFFFFff, "pbs/microphone.png");
	exitButtonSmall();
  end
end

function postPending()
updateTimer();
    if not POST then
	 State =3;
	 notifyOnce = 0;
	 animation_postSent = 0;
	else
	  if ui_size == "Default" then --UI Size Default
	    if lsAltHeld() then
		  safeClick(POST[0] + 25, POST[1] + 5);
		  lsPlaySound("scribble.wav");
		  p_yes = p_yes + 1;
		  State =3;
		  animation_postSent = 0;
		  notifyOnce = 0;
	    end
		
		if lsControlHeld() then
		  safeDrag(POST[0] - 10, POST[1] - 40, 25, 25, 1);
		  safeDrag(740, 80, atitd[0] - 40, 80, 1);
		end
		--SOUNDS
	    if sounds == "Loop" then
		  if animation_beep > 3000 then
			lsPlaySound("beepping.wav");
			animation_beep = 0;
		  else
			animation_beep = animation_beep + 100;
		  end
		elseif sounds == "On" then
		  if notifyOnce == 0 then
		    lsPlaySound("beepping.wav");
            notifyOnce = 1;
		  end
		end
			lsPrint(100, 25, 2, 0.7, 0.7, 0xFFFFFFFF, "Post(s) Pending");
			lsPrint(143, 125, 2, 2.0, 2.0, 0x55AAAAFF, p_yes);
			lsPrint(120, 220, 2, 0.7, 0.7, 0xFFFFFFFF, "(" .. h .. "h" ..  m .. "m".. s .. "s)");
			--Expand Post Window
			if lsButtonImg(200, 50, 3, 0.15, 0xFFFFFFff, "pbs/expand.png") then
			  safeDrag(POST[0] - 10, POST[1] - 40, 25, 25, 1);
			  safeDrag(740, 80, atitd[0] - 40, 80, 1);
			end
			--Save Post
			if lsButtonImg(220, 120, 3, 0.15, 0xFFFFFFff, "pbs/save.png") then
			  safeClick(POST[0] + 10, POST[1] + 5);
			  lsPlaySound("saved.wav");
			  p_saved = 1;
			end	
			--Send Post
			if lsButtonImg(50, 50, 1, 0.40, 0xFFFFFFff, "pbs/message.png") then
			  safeClick(POST[0] + 25, POST[1] + 5);
			  lsPlaySound("scribble.wav");
			  p_yes = p_yes + 1;
			  State =3;
			  animation_postSent = 0;
			  notifyOnce = 0;
			  lsPlaySound("successful.wav");
			end
			exitButton();
		else --UI Size Toolbar
		if lsAltHeld() then
		  safeClick(POST[0] + 25, POST[1] + 5);
		  lsPlaySound("scribble.wav");
		  p_yes = p_yes + 1;
		  State =3;
		  animation_postSent = 0;
		  notifyOnce = 0;
	    end
		
		if lsControlHeld() then
		  safeDrag(POST[0] - 10, POST[1] - 40, 25, 25, 1);
		  safeDrag(740, 80, atitd[0] - 40, 80, 1);
		end
		  --SOUNDS
	    if sounds == "Loop" then
		  if animation_beep > 3000 then
			lsPlaySound("beepping.wav");
			animation_beep = 0;
		  else
			animation_beep = animation_beep + 100;
		  end
		elseif sounds == "On" then
		  if notifyOnce == 0 then
		    lsPlaySound("beepping.wav");
            notifyOnce = 1;
		  end
		end
			lsPrint(165, 15, 2, 0.5, 0.5, 0xFFFFFFFF, "Post(s) Pending");
			lsPrint(260, 20, 2, 1.0, 1.0, 0xFFFFFFFF, p_yes);
			lsPrint(170, 30, 2, 0.7, 0.7, 0xFFFFFFFF, "(" .. h .. "h" ..  m .. "m".. s .. "s)");
			--Expand Post Window
			if lsButtonImg(105, 5, 5, 0.10, 0xFFFFFFff, "pbs/expand.png") then
			  safeDrag(POST[0] - 10, POST[1] - 40, 25, 25, 1);
			  safeDrag(740, 80, atitd[0] - 40, 80, 1);
			end
			--Save Post
			if lsButtonImg(55, 5, 5, 0.10, 0xFFFFFFff, "pbs/save.png") then
			  safeClick(POST[0] + 10, POST[1] + 5);
			  lsPlaySound("saved.wav");
			  p_saved = 1;
			end	
			--Send Post
			if lsButtonImg(5, 5, 1, 0.10, 0xFFFFFFff, "pbs/message.png") then
			  safeClick(POST[0] + 25, POST[1] + 5);
			  lsPlaySound("scribble.wav");
			  p_yes = p_yes + 1;
			  State =3;
			  animation_postSent = 0;
			  notifyOnce = 0;
			end
			exitButtonSmall();
		end
	end
	
end

function postSent()
  if ui_size == "Default" then --UI Size Default
    updateTimer();
    --Go to state 0 when 0.5 second passes.
    if animation_postSent > 500 then
	  State = 0;
	  notifyOnce = 0;
    else
	  if notifyOnce == 0 then
	    lsPlaySound("successful.wav");
		notifyOnce = 1;
	  end
	  lsPrint(110, 25, 2, 0.9, 0.9, 0xFFFFFFFF, "All Done!");
	  lsButtonImg(45, 49, 1, 0.85, 0xFFFFFFff, "pbs/yes.png");
	  exitButton();
	  POST = nil;
	  animation_postSent = animation_postSent + 100; 
    end
  else --UI Size Toolbar
	updateTimer();
    --Go to state 0 when 0.5 second passes.
    if animation_postSent > 500 then
	  State = 0;
	  notifyOnce = 0;
    else
	  if notifyOnce == 0 then
	    lsPlaySound("successful.wav");
		notifyOnce = 1;
	  end
	  lsPrint(65, 7, 2, 2.0, 2.0, 0xFFFFFFFF, "All Done!");
	  lsButtonImg(5, 5, 1, 0.20, 0xFFFFFFff, "pbs/yes.png");
	  exitButtonSmall();
	  POST = nil;
	  animation_postSent = animation_postSent + 100; 
    end
  end
end

function settingsMenu()
    updateTimer();
	lsPrint(120, 25, 1, 0.7, 0.7, 0xFFFFFFFF, "Settings");
	lsPrint(15, 55, 1, 0.7, 0.7, 0xFFFFFFFF, "UI Size");
	lsPrint(15, 80, 1, 0.6, 0.6, 0x55AAAAFF, "Default: Automato's default window size");
	lsPrint(15, 95, 1, 0.6, 0.6, 0x55AAAAFF, "Toolbar: Short & Thin. Takes less room");
	
	settings_y = 50;
	if ui_size == "Default" then 
	  lsButtonText(70, settings_y, 1, 100, 0x55AAAAFF, "Default");
	else
	  if lsButtonText(70, settings_y, 1, 100, 0x000000FF, "Default") then
	    ui_size = "Default";
	  end
	end
	if ui_size == "Toolbar" then
	  lsButtonText(180, settings_y, 1, 100, 0x55AAAAFF, "Toolbar");
	else
	  if lsButtonText(180, settings_y, 1, 100, 0x000000FF, "Toolbar") then
	    ui_size = "Toolbar";
	  end
	end
	
	settings_y = settings_y + 70;
	lsPrint(15, settings_y + 5, 1, 0.7, 0.7, 0xFFFFFFFF, "Sound");
	lsPrint(15, settings_y + 25, 1, 0.6, 0.6, 0x55AAAAFF, "On: Notify Once.   Loop: Notify until posted.");
	
	if sounds == "On" then
	  lsButtonText(70, settings_y, 1, 65, 0x55AAAAFF, "On");
	else
	  if lsButtonText(70, settings_y, 1, 65, 0x000000FF, "On") then
	    sounds = "On";
	  end
	end
	
	if sounds == "Off" then
	  lsButtonText(145, settings_y, 1, 65, 0x55AAAAFF, "Off");
	else
	  if lsButtonText(145, settings_y, 1, 65, 0x000000FF, "Off") then
	    sounds = "Off";
	  end
	end
	
	if sounds == "Loop" then
	  lsButtonText(220, settings_y, 1, 65, 0x55AAAAFF, "Loop");
	else
	  if lsButtonText(220, settings_y, 1, 65, 0x000000FF, "Loop") then
	    sounds = "Loop";
	  end
	end
	
	settings_y = settings_y + 50;	
	lsPrint(20, settings_y + 5, 1, 0.7, 0.7, 0xFFFFFFFF, "Log");
	lsPrint(15, settings_y + 30, 1, 0.6, 0.6, 0x55AAAAFF, "Enable/Disable Logging Info.");
	
	if logsession == "On" then
	  lsButtonText(70, settings_y, 1, 65, 0x55AAAAFF, "On");
	else
	  if lsButtonText(70, settings_y, 1, 65, 0x000000FF, "On") then
	    logsession = "On";
	  end
	end
	
	if logsession == "Off" then
	  lsButtonText(145, settings_y, 1, 65, 0x55AAAAFF, "Off");
	else
	  if lsButtonText(145, settings_y, 1, 65, 0x000000FF, "Off") then
	    logsession = "Off";
	  end
	end
	
	lsButtonImg(25, settings_y + 60, 8, 0.05, 0xFFFFFFff, "pbs/message.png");
	lsButtonImg(25, settings_y + 90, 8, 0.05, 0xFFFFFFff, "pbs/expand.png");
	lsButtonImg(25, settings_y + 120, 8, 0.05, 0xFFFFFFff, "pbs/save.png");
	lsPrint(55, settings_y + 65, 1, 0.6, 0.6, 0xFFFFFFFF, "Click this or push [ALT] to send post. ");
	lsPrint(55, settings_y + 95, 1, 0.6, 0.6, 0xFFFFFFFF, "Click this or push [CTRL] to expand. ");
	lsPrint(55, settings_y + 125, 1, 0.6, 0.6, 0xFFFFFFFF, "Click this to save post. ");
	
	
	if lsButtonText(0 - 20, lsScreenY - 30, z, 200, 0x000000FF, "Save") then
	  State=0;
    end
	
end



function startModding()
  if not Time then
    error "ATITD clock isn't visible or there are too many black pixels around it. Zoom in or change camera angle."
  end
  --Time Macro Started. (for pbslog.txt)
  timeStarted = "[" .. Date .. ", " .. Time .. "]";
  srReadScreen();
  atitd = srGetWindowSize();
  
  while not is_done do
	--Wait X seconds then read screen.
	if animation_readScreen > 1000 then
	  srReadScreen();
	  POST = srFindImage("pbs/S_P.png");
	  O_P = srFindImage("pbs/O_P.png");
	  animation_readScreen = 0;
	else
	  animation_readScreen = animation_readScreen + 100;
	end
	
	if POST then
	State = 1;
	end
	
	if O_P then
	p_saved = 1;
	else
	p_saved = 0;
	end
	
	--Determine Active Menu
	if State == 0 then
	  waitForPosts();
	elseif State == 1 then
	  postPending();
	elseif State == 2 then
	  settingsMenu();
	elseif State == 3 then
	  postSent();
	end

    if lsKeyDown("q") then
      is_done = 1;
	end	
	frame = frame + 100;
    lsDoFrame();
    lsSleep(100);
  end
end

